--[[
LuaX windowing system
test

]]

screen:clear()
screen.flip()
_bg = _bg or Image.load("background.png")
bg = bg or Image.load("bg.png")
screen:blit(0,0,_bg,false)
screen.flip()

dofile("LuaX.lua")
--dofile("pong.lua")
temp = Image.createEmpty(10,10)
temp:clear(Color.new(0,0,0))
cursor = {x=200,y=100,img=temp,visible=true,state="none"}
temp = nil
fps_timer = Timer.new()
fps = 60
system_h = 0 --0=nothing, 1=holding

LuaX_env = 1
LuaX_envs = {}
for a=1,4 do
LuaX_envs[a] = {windows = {}, window_co = {}, window_imgs = {},
				window_chg_atts = {}, statusbar_objects = {}}
end

function LuaX_load_env(x)
windows = LuaX_envs[x].windows
window_co = LuaX_envs[x].window_co
window_imgs = LuaX_envs[x].window_imgs
window_chg_atts = LuaX_envs[x].window_chg_atts
statusbar_objects = LuaX_envs[x].statusbar_objects
end

function LuaX_switch_env(x)
LuaX_env = x
LuaX_load_env(LuaX_env)
statusbar_redraw = true
end

LuaX_load_env(LuaX_env)

function test()
	--window.myButton.value = "test"..math.random(100)
	if math.random(10) == 2 then
	--window.title = "TestWindow" .. (string.sub(window.title,11)+1)
	--window.myTextBox.value="k'z"
	--LuaX_closewindow()
	end
end

tempi = Image.createEmpty(100,50)
tempi:clear(Color.new(0,255,0))

temp = {title="TestWindow1",id="TestWindow1",x=10,y=50,width=200,height=100,bgcolor=Color.new(100,100,100),
		func=test,Xlocked=0,Mlocked=0,
		myButton={type="button",x=10,y=10,color=Color.new(255,0,0),value="Test!",onClick=0},
		myTextBox={type="textbox",x=50,y=50,color=Color.new(255,255,255),value="hello world",onClick=function() window.myTextBox.value="click!" end} }
LuaX_regwindow(temp)

temp = {title="TestWindow2",id="TestWindow2",x=100,y=100,width=300,height=150,bgcolor=Color.new(100,200,200),
		func=0,Xlocked=0,Mlocked=0,
		myButton={type="button",x=10,y=10,color=Color.new(255,0,0),value="change image",onClick=function() window.myImage.value:clear(Color.new(255,0,0)); LuaX_redrawobject("myImage") end},
		myImage={type="image",x=10,y=60,value=tempi,onClick=0},
		myButton2={type="button",x=10,y=25,color=Color.new(255,0,0),value="Close Other Window",onClick=function() if LuaX_getWindowById("TestWindow1") then LuaX_closewindow(LuaX_getWindowById("TestWindow1")) end end},
		myButton3={type="button",x=10,y=40,color=Color.new(255,0,0),value="remove textbox",onClick=function() LuaX_removewindowobject("myTextBox",LuaX_getWindowById("TestWindow1")) window.title="hi" end} }
LuaX_regwindow(temp)


mp3status = 0

function playmp3()
if mp3status == 1 or mp3status == 2 then
	Mp3.pause()
	window.play.value = "Pause"
		if mp3status == 1 then
		window.play.value = "Play"
		mp3status = 2
		else
		mp3status = 1
		end
else
	Mp3.load("song.mp3")
	Mp3.play()
	mp3status = 1
	window.play.value = "Pause"
end
window.status.value="Playing..."
window.play.color = Color.new(255,0,0,240)
window.stop.color = Color.new(70,70,70,240)
LuaX_redrawwindow()
end

function stopmp3()
if mp3status == 1 or mp3status == 2 then
mp3status = 3
Mp3.stop()
window.status.value="Stopped"
window.stop.color = Color.new(255,0,0,240)
window.play.color = Color.new(70,70,70,240)
window.play.value = "Play"
LuaX_redrawwindow()
end
end

emp = ""

function lolz()

while true do
	for a=1,30 do
	sleep()
	end
	emp = emp .. "."
	if emp:len() >= 4 then emp = "" end
	window.title = "MP3 Player"..emp
end

end


temp = {title="MP3 Player",id="mp3player",x=10,y=50,width=200,height=100,bgcolor=Color.new(200,200,200,240),
		Xlocked=0,Mlocked=0,border=5,func=lolz111, barcolor=Color.new(255,255,255,180), barstyle=0,
		play={type="button",x=10,y=10,color=Color.new(70,70,70,240),value="Play",onClick=playmp3},
		stop={type="button",x=100,y=10,color=Color.new(70,70,70,240),value="Stop",onClick=stopmp3},
		status={type="textbox",x=50,y=30,color=Color.new(255,255,255),value="Press PLAY"} }
LuaX_regwindow(temp)


function testing()
	while true do
		sleep()
		if LuaX_mouseOverWindow() then
			window.mover.value="OVER!"
		else
			window.mover.value="mover"
		end
	end
end


temp = {title="Test",id="test",x=100,y=100,width=250,height=100,bgcolor=Color.new(100,100,200),
		Xlocked=0,Mlocked=0,border=1, barcolor=Color.new(0,0,255), barstyle=1, func=testing,
		min={type="button",x=10,y=10,color=Color.new(70,70,70,150),value="minimize",onClick=function() LuaX_minimizewindow() end},
		mover={type="button",x=100,y=70,color=Color.new(70,70,70,150),value="mover"},
		max={type="button",x=10,y=50,color=Color.new(70,70,70,150),value="maximize",onClick=function() LuaX_maximizewindow() end}}
--LuaX_regwindow(temp)

function lolz()
	while true do
		sleep()
		if LuaX_mouseOverObject("MyButton") then
			window.MyButton.color=Color.new(150,150,150)
		else
			window.MyButton.color=Color.new(70,70,70,150)
		end
	end
end


temp = {title="LuaX Example",id="example",x=10,y=50,width=200,height=100,bgcolor=Color.new(200,200,200,200),
		border=5,func=lolz, barcolor=Color.new(255,255,255,100), barstyle=0,
		MyButton={type="button",x=10,y=10,color=Color.new(70,70,70,150),value="hello!",onClick=function() window.MyButton.value="Click!"; window.status.value="You hit the button!" end},
		status={type="textbox",x=10,y=30,color=Color.new(255,255,255),value="Click above!"} }
--LuaX_regwindow(temp)


input = Controls.read()
oldinput = input


tempimg = Image.createEmpty(32,32)
		tempimg:clear(Color.new(0,0,255))
		tempimg:print(5,5,"hi",Color.new(255,255,255))

for a=1,3 do
LuaX_statusbar_addObject("test object"..a,"testobject"..a,nil,tempimg,nil)
end

function asdf()
	screen:clear()
	screen.flip()
	screen.waitVblankStart(5)
end

LuaX_desktop_addIcon("MP3 Player",tempimg,asdf,10,10)
LuaX_desktop_addIcon("MP3 Player2",tempimg,nil,20,20)
































while true do

fps_timer:reset()
fps_timer:start()

screen:clear(Color.new(100,100,255))
--screen:blit(0,0,_bg,false)

oldinput = input
input = Controls.read()

if input:select() and not oldinput:select() then
	LuaX_state = "syst"
elseif oldinput:select() and not input:select() then
	--placeholder, end system functions
	if LuaX_state == "cube" then
		local deg = math.mod(math.floor(math.deg(LuaX_cube_rot)),360)+50
		if deg < 0 then
			deg = deg + 360
		end
		deg = deg/90
		deg=math.floor(deg+.9)
		if deg == 5 then deg = 1 end
		if deg == 0 then deg = 4 end
		LuaX_switch_env(deg)
	end
	LuaX_state = "none"
	LuaX_windtab_fade = 0
	LuaX_windtab_d = 0
	LuaX_windtab_i = 0
	LuaX_windtab_done = 0
end

if LuaX_state == "syst" then
	if input:l() and input:r() and system_h == 0 then --alttab
		LuaX_state = "altb"
		statusbar_1_active = false
		statusbar_1_menuimg = nil
	end
elseif LuaX_state == "altb" and LuaX_windtab_type == 2 then
	if LuaX_windtab_done == 1 then
		if LuaX_windtab_d == 1 then
			a=1
			table.insert(windows,windows[a])
			table.remove(windows,a)
			table.insert(window_co,window_co[a])
			table.remove(window_co,a)
			table.insert(window_imgs,window_imgs[a])
			table.remove(window_imgs,a)
			table.insert(window_chg_atts,window_chg_atts[a])
			table.remove(window_chg_atts,a)
		elseif LuaX_windtab_d == -1 then
			a=table.getn(windows)
			table.insert(windows,1,windows[a])
			table.remove(windows,a+1)
			table.insert(window_co,1,window_co[a])
			table.remove(window_co,a+1)
			table.insert(window_imgs,1,window_imgs[a])
			table.remove(window_imgs,a+1)
			table.insert(window_chg_atts,1,window_chg_atts[a])
			table.remove(window_chg_atts,a+1)
		end
		LuaX_windtab_done = 0
		LuaX_windtab_d = 0
		LuaX_windtab_i = 0
	end
	if input:l() and input:r() and system_h == 0 then --3d cube
		LuaX_state = "cube"
		LuaX_cube_state = 0
		LuaX_cube_focalLength = 240
		LuaX_cube_rot = math.rad(LuaX_env*90-90)
		LuaX_cube_bgx = 0
	elseif input:r() and not oldinput:r() and LuaX_windtab_d == 0 then
			LuaX_windtab_d = 1
	elseif input:l() and not oldinput:l() then
			LuaX_windtab_d = -1
	end
elseif LuaX_state == "cube" then
	screen:blit(LuaX_cube_bgx,0,bg,false)
	screen:blit(LuaX_cube_bgx-480,0,bg,false)
	screen:fillRect(0,10,8*3,8,Color.new(255,255,255))
	 deg = math.mod(math.floor(math.deg(LuaX_cube_rot)),360)+50
		if deg < 0 then
			deg = deg + 360
		end
		deg = deg/90
		deg=math.floor(deg+.9)
		if deg == 5 then deg = 1 end
		if deg == 0 then deg = 4 end
	screen:print(0,10,deg)
end
if input:r() and input:l() then system_h = 1 end
if system_h == 1 and not (input:l() and input:r()) then system_h = 0 end

if LuaX_state ~= "cube" then
----------------------------------begin LuaX
LuaX_desktop_process()
LuaX_desktop_render()

LuaX_statusbar_process()
LuaX_windows_process()

if (statusbar_2_active or statusbar_type == 1) and LuaX_state ~= "altb" then
	LuaX_windows_render()
	LuaX_statusbar_render()
else
	LuaX_statusbar_render()
	LuaX_windows_render()
end
----------------------------------
else
	LuaX_cube_process()
end

if cursor.state == "icmv" then
	Gu.start3d()
	Gu.enable(Gu.TEXTURE_2D)
	local tempx = cursor.x - LuaX_desktop_icons[1][6]
	local tempy = cursor.y - LuaX_desktop_icons[1][7]
	temp = {{statusbar_2_icondim,statusbar_2_icondim,Color.new(255,255,255,100),tempx+statusbar_2_icondim,tempy+statusbar_2_icondim,0},
			{0,statusbar_2_icondim,Color.new(255,255,255,100),tempx,tempy+statusbar_2_icondim,0},
			{statusbar_2_icondim,0,Color.new(255,255,255,100),tempx+statusbar_2_icondim,tempy,0},
			{0,0,Color.new(255,255,255,100),tempx,tempy,0}}
	Gu.texImage(LuaX_desktop_icons[1][2])
	Gu.texFunc(Gu.TFX_MODULATE,Gu.TCC_RGBA)
	Gum.drawArray(Gu.TRIANGLE_STRIP, Gu.COLOR_8888+Gu.TEXTURE_32BITF+Gu.VERTEX_32BITF+Gu.TRANSFORM_2D, temp)
	Gu.end3d()
	
	--screen:blit(cursor.x - LuaX_desktop_icons[1][6],cursor.y - LuaX_desktop_icons[1][7],LuaX_desktop_icons[1][2])
	local str = string.sub(LuaX_desktop_icons[1][1],1,10)
	tempx = (cursor.x - LuaX_desktop_icons[1][6])+statusbar_2_icondim/2-string.len(str)*4
	local tempx2 = 0
	if tempx < 0 then
		tempx2 = math.ceil(-tempx/8)
		tempx = tempx + tempx2*8
	end
	_LuaX_ct(screen,tempx,(cursor.y - LuaX_desktop_icons[1][7])+statusbar_2_icondim+3,string.sub(str,tempx2+1))
end

screen:print(0,0,fps)
screen:print(100,0,LuaX_state)

if input:start() then break end

if cursor.visible and LuaX_state == "none" then
screen:blit(cursor.x,cursor.y,cursor.img)
end

screen.waitVblankStart()
screen.flip()
fps = math.floor(1000/fps_timer:time())
	if input:select() and input:triangle() then screen:save("screenshot"..math.random(1000)..".png") end
end